package ru.ifmo.paraschenko.objects;

/**
 * Description.
 *
 * @author Dmitry Paraschenko
 */
public interface ISuffixTree extends IGraph, IStringProcessor {
    public String getString();

    public char charAt(int pos);

    public int getEdge(int node, char c);

    public int getBegin(int edge);

    public void setBegin(int edge, int value);

    public int getEnd(int edge);

    public void setEnd(int edge, int value);

    public boolean isFinish(int node);

    public void setFinish(int node, boolean value);

    public int length();

    public int getSuffix(int node);

    public int process(String string);
}
