package ru.ifmo.paraschenko.objects;

import java.util.Iterator;

/**
 * Description.
 *
 * @author Dmitry Paraschenko
 */
public interface IGraph {
    public int getNodeCount();

    public int createNode();

    public int getEdgeCount();

    public int getEdge(int ver, char ch);

    public int addEdge(int src, char ch, int trg);

    public int getTarget(int edge);

    public void setTarget(int edge, int target);

    public Iterator<Integer> getEdgesIterator(int node);
}
