package ru.ifmo.paraschenko.objects;

import ru.ifmo.paraschenko.LargeInputSizeException;

/**
 * Description.
 *
 * @author Dmitry Paraschenko
 */
public interface IStringProcessorFactory<E extends IStringProcessor> {
    public E newInstance(String string) throws LargeInputSizeException;
}
